:- use_module(library(clpfd)).

money(Sol) :-
   Vars = [S,E,N,D,M,O,R,Y],
   Vars ins 0..9,
   Sol=sol(s:S,e:E,n:N,d:D,m:M,o:O,r:R,y:Y),
   all_different(Vars),
   M #\= 0, S #\= 0,
   S*1000 + E*100 + N*10 + D +
   M*1000 + O*100 + R*10 + E #=
   M*10000 + O*1000 + N*100 + E*10 + Y,
   labeling([leftmost],Vars).
